#include <bits/stdc++.h>
using namespace std;

void manacher(string w, int n, int*p, int sh) {
    int g = 0;
    p[0] = 1-sh;
    for(int i=1;i<n;i++) {
        p[i] = 2*g-i>=0?max(min(p[2*g-i],p[g]+g-i),0):0;
        while(i>=p[i]+sh && i+p[i]<n && w[i+p[i]]==w[i-p[i]-sh]) p[g=i]++;
    }
}

const int MAXN = 1e6;
int par[MAXN],nie[MAXN];

int main() {
    int n;
    cin >> n;
    string str;
    cin >> str;
    manacher(str,n,par,1);
    manacher(str,n,nie,0);
    
    int res = 1e9;
    for(int i=0;i<n;i++) {
        if(i+nie[i] == n) {
            res = min(res,n-2*nie[i]+1);
        }
    }
    for(int i=1;i<n;i++) {
        if(i+par[i] == n) {
            res = min(res,n-2*par[i]);
        }
    }
    cout<<res<<"\n";

}